﻿using BepInEx;
using BepInEx.Logging;
using Harmony;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using UnityEngine;
using UnityEngine.SceneManagement;

namespace KK_Ahegao
{

    [BepInPlugin(nameof(KK_Ahegao), nameof(KK_Ahegao), "1.6")]
    class KK_Ahegao : BaseUnityPlugin
    {
        private const uint AhegaoCount = 3;
        private static uint OrgasmCount = 0;

        private static bool cfgSetEyeBrows = true;
        private static bool cfgSetEyes = true;
        private static bool cfgSetMouth = true;
        private static bool cfgSpeedToggle = true;

        private static int cfgAhegaoEyebrow = 2;
        private static int cfgAhegaoEyes = 25;
        private static int cfgAhegaoMouth = 24;

        private static bool inHScene = false;

        private static HarmonyInstance hi;
        private static bool hold;
        private static bool fastEnough;
        private static List<ChaControl> lstFemale;
        private static string animName;
        private static bool isValidMode = false;

        private static bool isKiss = false;

        private List<HActionBase> lstProc = null;

        public KK_Ahegao()
        {
            SceneManager.sceneLoaded += SceneLoaded;
        }

        void SceneLoaded(Scene s, LoadSceneMode lsm)
        {
            var ihs = Singleton<HSceneProc>.Instance != null;
            if (!inHScene && ihs)
            {
                hold = false;
                fastEnough = false;
                animName = "";
                lstFemale = null;
                StartCoroutine(ResolveLstFemale());
            }
            inHScene = ihs;
        }

        IEnumerator ResolveLstFemale()
        {
            while (lstFemale == null || lstFemale?.Count == 0)
            {
                lstFemale = (List<ChaControl>)AccessTools.Field(typeof(HSceneProc), "lstFemale").GetValue(Singleton<HSceneProc>.Instance);
                yield return null;
            }
            lstProc = (List<HActionBase>)AccessTools.Field(typeof(HSceneProc), "lstProc").GetValue(Singleton<HSceneProc>.Instance);
            ReloadConfig();
            ResetAhegao();    //Reset orgasm counter on H scene entry.
            hi = HarmonyInstance.Create(nameof(KK_Ahegao));
            hi.PatchAll(typeof(KK_Ahegao));
        }

        void OnDestroy() => RemovePatches();

        private static void RemovePatches()
        {
            foreach (var met in typeof(KK_Ahegao).GetMethods().Where(x => x.IsStatic && x.IsPublic))
                foreach (var attr in met.GetCustomAttributes(false))
                    if (attr is HarmonyPatch)
                    {
                        var hp = (HarmonyPatch)attr;
                        var original = AccessTools.Method(hp.info.originalType, hp.info.methodName, hp.info.parameter);
                        hi.RemovePatch(original, met);
                    }
        }

        private void ReloadConfig()
        {
            BepInEx.Config.ReloadConfig();
            int.TryParse(BepInEx.Config.GetEntry(this, nameof(cfgAhegaoEyebrow), cfgAhegaoEyebrow.ToString()), out cfgAhegaoEyebrow);
            int.TryParse(BepInEx.Config.GetEntry(this, nameof(cfgAhegaoEyes), cfgAhegaoEyes.ToString()), out cfgAhegaoEyes);
            int.TryParse(BepInEx.Config.GetEntry(this, nameof(cfgAhegaoMouth), cfgAhegaoMouth.ToString()), out cfgAhegaoMouth);
            cfgSetEyeBrows = BepInEx.Config.GetEntry(this, nameof(cfgSetEyeBrows), cfgSetEyeBrows ? "1" : "0") == "1";
            cfgSetEyes = BepInEx.Config.GetEntry(this, nameof(cfgSetEyes), cfgSetEyes ? "1" : "0") == "1";
            cfgSetMouth = BepInEx.Config.GetEntry(this, nameof(cfgSetMouth), cfgSetMouth ? "1" : "0") == "1";
            cfgSpeedToggle = BepInEx.Config.GetEntry(this, nameof(cfgSpeedToggle), cfgSpeedToggle ? "1" : "0") == "1";
            BepInEx.Logger.Log(LogLevel.Info, "[KKAhegao] Config reloaded.");
            RefreshFace();
        }

        private static void AddOrgasm()
        {
            if (!isValidMode) return;
            if (!inHScene) return;
            if (++OrgasmCount >= AhegaoCount) RefreshFace();
        }

        private static void RefreshFace()
        {
            if (!isValidMode) return;
            foreach (var female in lstFemale)
            {
                female.ChangeEyebrowPtn(0);
                female.ChangeEyesPtn(0);
                female.ChangeMouthPtn(0);
            }
        }

        private static void ResetAhegao()
        {
            OrgasmCount = 0;
            RefreshFace();
        }

        void Update()
        {
            if (!inHScene || lstFemale == null || lstFemale.Count == 0) return;

            var cc = lstFemale.First();
            if (cc == null) return;
            var hsp = Singleton<HSceneProc>.Instance;
            if (hsp == null) return;

            if (Input.GetKeyDown(KeyCode.O)) ResetAhegao();
            if (Input.GetKeyDown(KeyCode.P)) ReloadConfig();

            if (hsp.hand)
            {
                var ik = hsp.hand.IsKissAction();
                var isKissJustChanged = (!isKiss && ik);
                isKiss = ik;
                if(isKissJustChanged) RefreshFace();
            }
            if (isKiss) return;

            //Force refresh of face when adjusting speed.
            var fe = hsp.flags.speed > 2f;
            if (fe != fastEnough)
            {
                fastEnough = fe;
                RefreshFace();
            }
            //Allow face state to remain when transitioning to orgasm animation.
            var aci = cc.animBody.GetCurrentAnimatorClipInfo(0);
            if (aci.Length == 0) return;
            var an = aci[0].clip.name;
            if (animName != an)
            {
                hold = false;
                animName = an;
                var mode = lstProc[(int)hsp.flags.mode];
                isValidMode = mode is HSonyu || mode is HAibu;
                var hl = an.Contains("Loop1") || an.Contains("Loop2") || an.Contains("OLoop") || an.Contains("IN_Start") || an.Contains("IN_Loop") || an.Contains("_IN_A");
                var rf = an.Contains("Idle") || an.Contains("OUT_A") || an.Contains("OUT_Start") || an.Contains("OUT_Loop");// || an.Contains("_IN_A") || an.Contains("OUT_Start") || an.Contains("OUT_Loop") || an.Contains("OUT_A");
                if(hl) hold = true;
                else if(rf)
                {
                    if(!(mode is HAibu)) //Ignore caress mode.
                    {
                        hsp.flags.speed = 0f;
                        RefreshFace();
                    }
                }
            }
        }

        [HarmonyPostfix, HarmonyPatch(typeof(HFlag), "AddAibuOrg")] //Foreplay
        public static void AddAibuOrg() => AddOrgasm();

        [HarmonyPostfix, HarmonyPatch(typeof(HFlag), "AddSonyuOrg")]    //Vaginal
        public static void AddSonyuOrg() => AddOrgasm();

        [HarmonyPostfix, HarmonyPatch(typeof(HFlag), "AddSonyuAnalOrg")]    //Anal
        public static void AddSonyuAnalOrg() => AddOrgasm();

        [HarmonyPrefix, HarmonyPatch(typeof(ChaControl), "ChangeEyebrowPtn")]
        public static bool ChangeEyebrowPtn(ChaControl __instance, ref int ptn)
        {
            if (!isValidMode) return true;
            if (!cfgSetEyeBrows) return true;
            if (isKiss) return true;
            if (!lstFemale.Contains(__instance) || OrgasmCount < AhegaoCount || !inHScene) return true;
            if (cfgSpeedToggle && !fastEnough || !hold) ptn = 0;
            else ptn = cfgAhegaoEyebrow;
            return true;
        }

        [HarmonyPrefix, HarmonyPatch(typeof(ChaControl), "ChangeEyesPtn")]
        public static bool ChangeEyesPtn(ChaControl __instance, ref int ptn)
        {
            if (!isValidMode) return true;
            if (!cfgSetEyes) return true;
            if (isKiss) return true;
            if (!lstFemale.Contains(__instance) || OrgasmCount < AhegaoCount || !inHScene) return true;
            if (cfgSpeedToggle && !fastEnough || !hold) ptn = 0;
            else ptn = cfgAhegaoEyes;
            return true;
        }

        [HarmonyPrefix, HarmonyPatch(typeof(ChaControl), "ChangeMouthPtn")]
        public static bool ChangeMouthPtn(ChaControl __instance, ref int ptn)
        {
            if (!isValidMode) return true;
            if (!cfgSetMouth) return true;
            if (isKiss) return true;
            if (!lstFemale.Contains(__instance) || OrgasmCount < AhegaoCount || !inHScene) return true;
            if (cfgSpeedToggle && !fastEnough || !hold) ptn = 0;
            else ptn = cfgAhegaoMouth;
            return true;
        }

        [HarmonyPostfix, HarmonyPatch(typeof(HSceneProc), "EndProc")]
        public static void EndProc()
        {
            if (!inHScene) return;
            inHScene = false;
            RemovePatches();
        }
    }
}
